import matplotlib.pyplot as plt
import numpy as np


NAME = "250_10_0"

plt.rcParams['pdf.fonttype'] = 42
plt.rcParams['ps.fonttype'] = 42


def num(line):
    try:
        return int(line)
    except ValueError:
        nume, deno = line.split('/')
        return float(float(nume) / float(deno))
  

def writelist(L, name):
    out = name + "\t"
    for x in L:
        out = out + str(x) + "\t"
    out = out + "\n"
    out = out.replace(".", ",")
    return out
    


def readFileMinPlus(name):   
    
  
    f = open(name + "/" + name + '.out', 'r')
    
    delay_M1 = []
    delay_M2 = []
    delay_M3 = []
    delay_M7 = []    

    k_M1 = 1
    k_M2 = 1
    k_M3 = 1
    k_M7 = 1
    
    test_M1 = False
    test_M7 = False
    test_M2 = False
    test_M3 = False
    
    for line in f.readlines():


        if test_M1:            
            if line != "+Infinity" + "\n":
                n = num(line)
            else:
                n = 1000
            delay_M1.append(n)
            k_M1 = k_M1 + 1
        if line == ">>dM1_" + str(k_M1) + "\n":
            test_M1 = True
        else:
            test_M1 = False
            
        if test_M2:            
            if line != "+Infinity" + "\n":
                n = num(line)
            else:
                n = 1000
            delay_M2.append(n)
            k_M2 = k_M2 + 1
        if line == ">>dM2_" + str(k_M2) + "(0+)" + "\n":
            test_M2 = True
        else:
            test_M2 = False
        
        if test_M3:            
            if line != "+Infinity" + "\n":
                n = num(line)
            else:
                n = 1000
            delay_M3.append(n)
            k_M3 = k_M3 + 1
        if line == ">>dM3_" + str(k_M3) + "\n":
            test_M3 = True
        else:
            test_M3 = False
            
        if test_M7:            
            if line != "+Infinity" + "\n":
                n = num(line)
            else:
                n = 1000
            delay_M7.append(n)
            k_M7 = k_M7 + 1
        if line == ">>dM7_" + str(k_M7) + "\n":
            test_M7 = True
        else:
            test_M7 = False


            
    f.close()
    
    
    
    delay_M1 = np.asanyarray(delay_M1)
    delay_M7 = np.asanyarray(delay_M7)
    delay_M2 = np.asanyarray(delay_M2)
    delay_M3 = np.asanyarray(delay_M3)
      
    output_file = open(name + "/" + "result", 'w')
    output_file.write(writelist(delay_M1, "Phases: Method 1"))
    output_file.write(writelist(delay_M2, "Phases: Method 2"))
    output_file.write(writelist(np.minimum(delay_M3, delay_M7), "Phases: Method 3"))
    output_file.write(writelist(delay_M7, "No offsets: Method 7"))
    output_file.close()
    
              
    plt.figure(name.split("_")[2])
    plt.plot(delay_M1, 'g:*', label="Phases: Method 1")
    plt.plot(delay_M2, 'b:o', label="Phases: Method 2")
    plt.plot(delay_M3, 'm:s', label="Phases: Method 3")
    plt.plot(delay_M7, 'g:o', label="No offsets: Method 7")
    plt.plot()
    plt.legend()
    plt.xlim((0, 62))
    plt.ylim((0, 14))
    plt.ylabel('Response times in ms')
    plt.xlabel('Frame by decreasing priority')
    plt.grid(True)
    plt.title("Phases bouded by " + name.split("_")[2] + " ms.")
    plt.legend(loc='upper left')
    return SP



        
SP = [[], []]
SP = readFileMinPlus(NAME)


plt.show()
