import os
from math import *
import numpy as np

CONFIG = "config"
LINK_SPEED = 250.0
END_SYSTEM_NB = 10
PHASE_BOUND = 0



def comp(v1, v2):
    if v1["priority"] < v2["priority"]:
        return -1
    else:
        return 0


def ppcm(*n):

    def _pgcd(a, b):
        while b: a, b = b, a % b
        return a
    
    p = abs(n[0] * n[1]) // _pgcd(n[0], n[1])
    for x in n[2:]:
        p = abs(p * x) // _pgcd(p, x)
    return p


def newframe(size, period, offset, priority, ES):
    f = {}
    f["size"] = size
    f["period"] = period
    f["offset"] = offset * 1.0
    f["priority"] = priority
    f["ES"] = ES
    return f
    

def commonP(transaction):
    T = []
    periodC = -1
    
    for f in transaction:
        periodC = ppcm(periodC, f["period"])
    
    for frame in transaction:
        for k in range(0, periodC / frame["period"]):
            T.append(newframe(frame["size"], periodC, frame["offset"] + k * frame["period"], frame["priority"], frame["ES"]))
    return T 

def arrival(transaction, n):
    
    T_n = []
    for frame in transaction:
        if frame["priority"] <= n:
            T_n.append(frame)

    Toutput = []
    k = 0
    for fi in T_n:
        k = k + 1
        for fj in T_n:
            Toutput.append(newframe(fj["size"], fj["period"], max(0, fj["offset"] - fi["offset"] - Synchro[fi["ES"] - 1][fj["ES"] - 1] + ceil((fi["offset"] - fj["offset"] - Synchro[fj["ES"] - 1][fi["ES"] - 1]) * 1.0 / fj["period"]) * fj["period"]), k, 0))
            
    return Toutput


def createFileMinPlus(name, transaction):   
        
    # trier la liste
    transaction.sort(cmp=comp) 
    output_file = open(name + "/" + name + '.nc', 'w')
    
        
    # creation A_i de priorite i
    text = "A:="
    for frame in transaction:
        output_file.write("A" + str(frame["priority"]) + ":=" + "stair(" + str(frame["offset"]) + "," + str(frame["period"]) + "," + str(frame["size"]) + ")" + "\n")
        text = text + "A" + str(frame["priority"]) + "+"  
    output_file.write(text[:len(text) - 1] + "\n" + "\n")    

    TcommonP = commonP(transaction)

    output_file.write("beta:= affine(" + str(beta / 8) + ",0)" + "\n")
  
    # creation alpha_i CA des flux 1:i
    alpha_k = np.asanyarray([[0] * TcommonP[0]["period"]] * len(TcommonP))
    
    for k in range(0, len(transaction)):
        alpha_k = alpha_k * 0.0
        Alpha = arrival(TcommonP, k + 1)
        Alpha.sort(cmp=comp)
        
        
        print k + 1, len(Alpha)
       
        for a in Alpha:
            alpha_k[a["priority"] - 1][a["offset"]:] = alpha_k[a["priority"] - 1][a["offset"]:] + a["size"]


        A_k = []
        for l in range(0, TcommonP[0]["period"]):
            A_k.append(alpha_k[:, l].max())
        
        
        text_alpha = "alpha" + str(k + 1) + ":="
        s_0 = 0
        x = 0
        for size in A_k:
            if size - s_0 > 0:
                text_alpha = text_alpha + "stair(" + str(x) + "," + str(TcommonP[0]["period"]) + "," + str(size - s_0) + ")+"
            x = x + 1
            s_0 = size
        output_file.write(text_alpha[:len(text_alpha) - 1] + "\n")
    
    
    output_file.write("beta_" + "1" + ":=upclosure(beta" + "-step(0," + str((8 + 44.0 / 8.0) * bitstuffing) + ")" + ")" + "\n")
    for k in range(1, len(transaction)):
        output_file.write("beta_" + str(k + 1) + ":=upclosure(beta-alpha" + str(k) + "-step(0," + str((8 + 44.0 / 8.0) * bitstuffing) + ")" + ")" + "\n")
    
        
    for k in range(1, len(transaction) + 1):
        output_file.write("dM1_" + str(k) + ":=hDev((A" + str(k) + "/A" + str(k) + "),beta_" + str(k) + ")" + "\n")
        output_file.write("dM1_" + str(k) + "\n")
        
    for k in range(1, len(transaction) + 1):
        Asup = ""
        Ainf = "("
        for frame in transaction[:k - 1]:            
            Ainf = Ainf + "stair(" + str(frame["offset"] + 1000 + Synchro[frame["ES"] - 1][transaction[k - 1]["ES"] - 1]) + "," + str(frame["period"]) + "," + str(frame["size"]) + ")+"
            Asup = Asup + "-stair(" + str(frame["offset"] + 1000 - Synchro[frame["ES"] - 1][transaction[k - 1]["ES"] - 1]) + "," + str(frame["period"]) + "," + str(frame["size"]) + ")"
        Ainf = Ainf + "stair(" + str(transaction[k - 1]["offset"] + 1000) + "," + str(transaction[k - 1]["period"]) + "," + str((8 + 44.0 / 8.0) * bitstuffing) + ")"
        if k > 0:
            output_file.write("dM3_" + str(k) + ":=hDev(stair(" + str(transaction[k - 1]["offset"] + 1000) + "," + str(transaction[k - 1]["period"]) + "," + str((8 + 44.0 / 8.0) * bitstuffing) + ")" + ",upclosure(" + Ainf + ")*beta" + Asup + ")) + " + str(transaction[k - 1]["size"] / (beta / 8.0)) + "\n")
            output_file.write("dM3_" + str(k) + "\n")
    
    
    for k in range(1, len(transaction) + 1):
        output_file.write("dM2_" + str(k) + ":=inv(upclosure(beta-alpha" + str(k) + "-step(0," + str((8 + 44.0 / 8.0) * bitstuffing) + ")))" + "\n")
        output_file.write("dM2_" + str(k) + "(0+)" + "\n")
  
    Ainf = ""
    for k in range(1, len(transaction) + 1):
        output_file.write("dM7_" + str(k) + ":=hDev((" + "stair(0 ," + str(frame["period"]) + "," + str((8 + 44.0 / 8.0) * bitstuffing) + ")" + "),upclosure(beta" + Ainf + "))" + " + " + str(transaction[k - 1]["size"] / (beta / 8.0)) + "\n")
        Ainf = Ainf + "-A" + str(k) + "/A" + str(k)
        output_file.write("dM7_" + str(k) + "\n")
     
    output_file.close()
    
    print("Cr" + u"\u00E9" + "ation de : " + name + ".nc dans " + os.getcwd())




Erreur = PHASE_BOUND
beta = LINK_SPEED

NB_ES = END_SYSTEM_NB
Synchro = (np.ones(NB_ES) - np.eye(NB_ES)) * Erreur
bitstuffing = 1.25


T = []

file_input = open(CONFIG, 'r')
k = 0
for line in file_input.readlines():
    if line.split()[0] != 'Flow':
        k = k + 1
        S = int(line.split()[1])
        RealS = (S + 44.0 / 8.0) * bitstuffing
        P = int(line.split()[2])
        O = int(line.split()[3])        
        ES = int(line.split()[4])
        
        f = newframe(RealS, P, O , k, ES)
        T.append(f)


try:
    os.mkdir(str(int(beta)) + '_' + str(NB_ES) + '_' + str(Erreur))
except OSError:
    pass
    

createFileMinPlus(str(int(beta)) + '_' + str(NB_ES) + '_' + str(Erreur), T)
